/***********************************************************
 * $Id: ComparatorFactory.java 20 2007-03-01 10:45:50Z wglas $
 * 
 * Utility classes of the clazzes.org project
 * http://www.clazzes.org
 *
 * Created: Feb 28, 2007
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 * 
 ***********************************************************/

package org.clazzes.util.comparators;

import java.util.Comparator;

/**
 * Implementations of this interface generate comparators for a
 * given class. 
 * 
 * @author wglas
 */
public interface ComparatorFactory {

    /**
     * Get a comparator, which compares instances of the given class.
     * 
     * @param clazz The class, which will be compared by the returned Comparator.
     * 
     * @return A Comparator, which handles objects of the supplied class.
     */
    public Comparator getComparator(Class clazz);
}
